from time import sleep

import yaml
from faker import Faker
from selenium import webdriver
from selenium.webdriver.common.by import By
from selenium.webdriver.support import expected_conditions
from selenium.webdriver.support.wait import WebDriverWait


class TestaddBm:

    def setup_class(self):

        fake = Faker("zh_CN")
        self.username = fake.name()
        self.accid = fake.ssn()
        self.mobile = fake.phone_number()


        self.driver = webdriver.Chrome()

        self.driver.get("https://work.weixin.qq.com/wework_admin/loginpage_wx")

        with open("./data/cookies.yaml" , "r") as f:
            cookies = yaml.safe_load(f)

            for ck in cookies:
                self.driver.add_cookie(ck)

            self.driver.get("https://work.weixin.qq.com/wework_admin/loginpage_wx")

    def teardown_class(self):
        self.driver.quit()

    def test_add_bm(self):


        self.driver.find_element(By.LINK_TEXT, "通讯录").click()
        sleep(2)

        self.driver.find_element(By.XPATH, "//i[@class='member_colLeft_top_addBtn']").click()

        self.driver.find_element(By.XPATH, "//a[text()='添加部门']").click()

        self.driver.find_element(By.XPATH, "//input[@name='name']").send_keys(self.username)

        self.driver.find_element(By.LINK_TEXT, "选择所属部门").click()

        self.driver.find_element(By.XPATH, "//div[@class='inputDlg_item']//a[text()='测试']").click()

        self.driver.find_element(By.XPATH, "//a[text()='确定']").click()

        tips = (By.ID, "js_tips")
        #显示等待WebDriverWait().until()

        WebDriverWait(self.driver, 10, 2).until(expected_conditions.visibility_of_element_located(tips))
        #获取断言标签的文本
        tips_value = self.driver.find_element(*tips).text

        assert "新建部门成功" == tips_value


