from faker import Faker
from selenium.webdriver.common.by import By

from test_web_ui.test_po.Page_Object.basepage import BasePage


class AddMemberPage(BasePage):


    __SED_USERNAME =(By.ID, "username")
    __SED_ADDID = (By.ID, "memberAdd_acctid")
    __SED_PHONE = (By.ID, "memberAdd_phone")
    __SAVE = (By.CSS_SELECTOR, "a.qui_btn.ww_btn.js_btn_save")

    def add_info(self):
        fake = Faker("zh_CN")
        self.username = fake.name()
        self.accid = fake.ssn()
        self.mobile = fake.phone_number()


        self.do_sendkeys(self.username, self.__SED_USERNAME)

        self.do_sendkeys(self.accid, self.__SED_ADDID)

        self.do_sendkeys(self.mobile, self.__SED_PHONE)

        self.do_finds(self.__SAVE)[0].click()

        from test_web_ui.test_po.Page_Object.contact_page import ContactPage
        return ContactPage(self.driver)
