import configparser
import os
import time

from selenium import webdriver
from selenium.webdriver.chrome.options import Options
from selenium.webdriver.support import expected_conditions
from selenium.webdriver.support.wait import WebDriverWait

from test_web_ui.test_po.utils.log_until import logger
from test_web_ui.test_po.utils.utils import Utils


class BasePage:

    _BASE_URL_ = "" #定义一个新浏览器

    def __init__(self, basedriver=None):

        # fake = Faker("zh_CN")
        # self.username = fake.name()
        # self.accid = fake.ssn()
        # self.mobile = fake.phone_number()

        config = configparser.ConfigParser()
        path = os.path.dirname(Utils.frame_path())
        # path_file = os.sep.join([path, "iselenium.ini"])
        config.read(os.path.join(path, "iselenium.ini"), encoding="utf-8")
        #判断如果当前存在浏览器则为driver 如果没有则新建一个driver
        if basedriver:
            logger.info("66666")
            self.driver = basedriver
        else:
            try:
                logger.info("222222")
                using_header = os.environ["using_header"]
            except KeyError:
                logger.info("33333")
                using_header = None
                logger.info("按照有界面方式运行")
            logger.info("444444")
            chrome_options = Options()
            logger.info("555555")
            if using_header is not None and using_header.lower() == 'true':
                logger.info("按照无界面方式运行")
            chrome_options.add_argument("--headless")
            chrome_options.add_argument("window-size=1920,1080")
            chrome_options.add_argument("--disable-gpu")
            chrome_options.add_argument("--disable-gpu")
            logger.info("111111")
            self.driver = webdriver.Chrome(executable_path=config.get('driver', 'chrome_driver'), options=chrome_options)
            # self.driver.maximize_window()
            self.driver.implicitly_wait(5)
            self.driver.get_screenshot_as_file("./1.png")
            time.sleep(1)
            self.driver.get_screenshot_as_file("./2.png")
            time.sleep(1)
            self.driver.get_screenshot_as_file("./3.png")
        #当前浏览器非http开头 需要获取一个新浏览器地址
        if not self.driver.current_url.startswith("http"):
            self.driver.get(self._BASE_URL_)


    # 获取单个元素 需要return返回给调用去使用
    def do_find(self, by, locator=None):

        if locator:
            return self.driver.find_element(by, locator)
        else:
            return self.driver.find_element(*by)
    # 获取多个元素有数组的
    def do_finds(self, by, locator=None):

        if locator:
            return self.driver.find_elements(by, locator)
        else:
            return self.driver.find_elements(*by)

    #直接输入框输入值 传入value by locator
    def do_sendkeys(self, value, by, locator=None):
        if locator:
            els = self.driver.find_element(by, locator)
            els.clear()
            els.send_keys(value)
        else:
            els = self.driver.find_element(*by)
            els.clear()
            els.send_keys(value)
    #显示等待的方法传入元素 元组
    def wait_expect(self, locator : tuple):

        return WebDriverWait(self.driver, 10, 2)\
            .until(expected_conditions.visibility_of_element_located(locator))

    def do_quit(self):

        self.driver.quit()